import { Checker, BaseInterface, MicroTest, Utility } from './index.js';
import { NumbersValidator } from '@pro-script/as-is-plugins/numbers';
import { StringsValidator } from '@pro-script/as-is-plugins/strings';
const checker = new Checker({
    'IF/ELSE/END': true,
    strict: true,
    Enum: true,
    utility: true,
    integrate: Object.assign(NumbersValidator, StringsValidator)
});
const { multi, Interface, Type, as, is, IF, ELSE, END, optional, get, macro, strict, Enum } = checker;
const { START, STOP, FINISH, METHOD, PROPERTY, IS, CHECK, passed, failed } = new MicroTest({ is, as });
const roles = Enum.roles({
    admin: 0,
    user: 1
});
console.log(as.Enum(roles))

const fakeEnum = Enum.new({
    name: 'admin',
    value: 0
});
console.log('is.Enum', is.Enum(fakeEnum));


const { IUser } = Type({
    IUser: {
        name: as.string,
        email: as.email,
        password: as.string,
        avatar: (value)=> {
            as.url(value);
            as.minStr({arg: value, value: 3});
            as.maxStr({arg: value, value: 40});
        },
        role:(value)=> {
            console.log(value)
        }
    }
});

const result = as.IUser({
    name: 'name',
    email: 'name@domain.com',
    password: 'qweqweqweqwe',
    avatar: 'http://url.com',
    role: 'admin'
});
console.log(result);